//
// file :         readthread.h
//
// description :  reading thread
//
// project :      TANGO Device Server
//
// $Author: graziano $ 
//
// $Revision: 1.2 $
//
// $Log: readthread.h,v $
// Revision 1.2  2009/10/02 15:30:59  graziano
// improved precision of scan period
//
// Revision 1.1  2009/09/22 12:10:18  graziano
// first commit
//
//
//
//
//
// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AREA Science Park
//              34012 Basovizza, Trieste ITALY
//


#ifndef READTHREAD_H
#define READTHREAD_H

#include <omnithread.h>
#include <tango.h>
#include <Keithley2701.h>

class readthread : public omni_thread, public Tango::LogAdapter 
{	
	private:
		Keithley2701_ns::Keithley2701 *mydevice;
		void abort_sleep(double time);
		void abort_sleep_precise(timeval from, double time);
		unsigned long diff_time(struct timeval start, struct timeval end);
				
	public:
		
		readthread(Keithley2701_ns::Keithley2701 *s);
		~readthread();
					
	protected:
		void run(void *);
		
};	/* end class readthread() */



#endif

/* EOF */
